/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.gen.profiler.provider;

import fr.obeo.acceleo.gen.profiler.ProfileEntry;
import fr.obeo.acceleo.gen.profiler.ProfilerFactory;
import fr.obeo.acceleo.gen.profiler.ProfilerPackage;

import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.Collection;
import java.util.List;
import java.util.MissingResourceException;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link fr.obeo.acceleo.gen.profiler.ProfileEntry} object.
 * <!-- begin-user-doc
 * --> <!-- end-user-doc -->
 * @generated
 */
public class ProfileEntryItemProvider extends ItemProviderAdapter implements IEditingDomainItemProvider, IStructuredItemContentProvider, ITreeItemContentProvider, IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ProfileEntryItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public List getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addDurationPropertyDescriptor(object);
			addCountPropertyDescriptor(object);
			addMonitoredPropertyDescriptor(object);
			addPercentagePropertyDescriptor(object);
			addTextBeginPropertyDescriptor(object);
			addTextEndPropertyDescriptor(object);
			addCreateTimePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Duration feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addDurationPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ProfileEntry_duration_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ProfileEntry_duration_feature", "_UI_ProfileEntry_type"),
				 ProfilerPackage.Literals.PROFILE_ENTRY__DURATION,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.INTEGRAL_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Count feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addCountPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ProfileEntry_count_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ProfileEntry_count_feature", "_UI_ProfileEntry_type"),
				 ProfilerPackage.Literals.PROFILE_ENTRY__COUNT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.INTEGRAL_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Monitored feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addMonitoredPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ProfileEntry_monitored_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ProfileEntry_monitored_feature", "_UI_ProfileEntry_type"),
				 ProfilerPackage.Literals.PROFILE_ENTRY__MONITORED,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Percentage feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addPercentagePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ProfileEntry_percentage_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ProfileEntry_percentage_feature", "_UI_ProfileEntry_type"),
				 ProfilerPackage.Literals.PROFILE_ENTRY__PERCENTAGE,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.REAL_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Text Begin feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addTextBeginPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ProfileEntry_textBegin_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ProfileEntry_textBegin_feature", "_UI_ProfileEntry_type"),
				 ProfilerPackage.Literals.PROFILE_ENTRY__TEXT_BEGIN,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.INTEGRAL_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Text End feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addTextEndPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ProfileEntry_textEnd_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ProfileEntry_textEnd_feature", "_UI_ProfileEntry_type"),
				 ProfilerPackage.Literals.PROFILE_ENTRY__TEXT_END,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.INTEGRAL_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Create Time feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addCreateTimePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ProfileEntry_createTime_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ProfileEntry_createTime_feature", "_UI_ProfileEntry_type"),
				 ProfilerPackage.Literals.PROFILE_ENTRY__CREATE_TIME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.INTEGRAL_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Collection getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(ProfilerPackage.Literals.PROFILE_ENTRY__CALLEES);
		}
		return childrenFeatures;
	}

	/**
	 * This returns ProfileEntry.gif. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated NOT
	 */
	public Object getImage(Object object) {
		final int spacePos = ((ProfileEntry) object).getMonitored().indexOf(" ");
		String name = ""; //$NON-NLS-1$
		if (spacePos > -1) {
			name = "full/obj16/" + ((ProfileEntry) object).getMonitored().substring(0, spacePos); //$NON-NLS-1$
		}
		try {
			return overlayImage(object, getResourceLocator().getImage(name));
		} catch (MissingResourceException e) {
			return overlayImage(object, getResourceLocator().getImage("full/obj16/ProfileEntry"));
		}
	}

	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public String getText(Object object) {
		final ProfileEntry profileEntry = (ProfileEntry) object;
		final NumberFormat format = new DecimalFormat();
		format.setMaximumIntegerDigits(3);
		format.setMaximumFractionDigits(2);
		return format.format(profileEntry.getPercentage()) + "% / " + profileEntry.getDuration() + "ms / " + profileEntry.getCount() + " times [" + profileEntry.getMonitored() + "]";
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(ProfileEntry.class)) {
			case ProfilerPackage.PROFILE_ENTRY__DURATION:
			case ProfilerPackage.PROFILE_ENTRY__COUNT:
			case ProfilerPackage.PROFILE_ENTRY__MONITORED:
			case ProfilerPackage.PROFILE_ENTRY__PERCENTAGE:
			case ProfilerPackage.PROFILE_ENTRY__TEXT_BEGIN:
			case ProfilerPackage.PROFILE_ENTRY__TEXT_END:
			case ProfilerPackage.PROFILE_ENTRY__CREATE_TIME:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case ProfilerPackage.PROFILE_ENTRY__CALLEES:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(ProfilerPackage.Literals.PROFILE_ENTRY__CALLEES,
				 ProfilerFactory.eINSTANCE.createProfileEntry()));

		newChildDescriptors.add
			(createChildParameter
				(ProfilerPackage.Literals.PROFILE_ENTRY__CALLEES,
				 ProfilerFactory.eINSTANCE.createLoopProfileEntry()));
	}

	/**
	 * Return the resource locator for this item provider's resources. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ResourceLocator getResourceLocator() {
		return ProfilerEditPlugin.INSTANCE;
	}

}
